From ada1179fa4acca4fa911f624dc630aec7931371c Mon Sep 17 00:00:00 2001
From: Jeffy Chen <jeffy.chen@rock-chips.com>
Date: Tue, 19 Sep 2023 11:05:33 +0800
Subject: [PATCH 27/98] Support hiding cursor

Add below to weston.ini:
[shell]
hide-cursor=true

Signed-off-by: Jeffy Chen <jeffy.chen@rock-chips.com>
---
 compositor/main.c             | 4 ++++
 include/libweston/libweston.h | 2 ++
 libweston/compositor.c        | 3 +++
 3 files changed, 9 insertions(+)

diff --git a/compositor/main.c b/compositor/main.c
index c829e9d..bb582ec 100644
--- a/compositor/main.c
+++ b/compositor/main.c
@@ -4400,6 +4400,10 @@ wet_main(int argc, char *argv[], const struct weston_testsuite_data *test_data)
 		}
 	}
 
+	section = weston_config_get_section(config, "shell", NULL, NULL);
+	weston_config_section_get_bool(section, "hide-cursor",
+				       &wet.compositor->hide_cursor, false);
+
 	for (i = 1; i < argc; i++)
 		weston_log("fatal: unhandled option: %s\n", argv[i]);
 	if (argc > 1)
diff --git a/include/libweston/libweston.h b/include/libweston/libweston.h
index 79c9172..9e15583 100644
--- a/include/libweston/libweston.h
+++ b/include/libweston/libweston.h
@@ -1540,6 +1540,8 @@ struct weston_compositor {
 	struct weston_output *prefer_output;
 
 	bool warm_up;
+
+	bool hide_cursor;
 };
 
 struct weston_solid_buffer_values {
diff --git a/libweston/compositor.c b/libweston/compositor.c
index f106266..b240040 100644
--- a/libweston/compositor.c
+++ b/libweston/compositor.c
@@ -3387,6 +3387,9 @@ weston_compositor_build_view_list(struct weston_compositor *compositor)
 	wl_list_for_each(layer, &compositor->layer_list, link) {
 		bool system_layer = weston_compositor_is_system_layer(layer);
 
+		if (compositor->hide_cursor && layer == &compositor->cursor_layer)
+			continue;
+
 		wl_list_for_each(view, &layer->view_list.link, layer_link.link) {
 			if (compositor->warm_up && !system_layer) {
 				weston_log("seeing the first app\n");
-- 
2.20.1

